Package org.apache.cxf.transport

## Class AbstractMultiplexDestination

- java.lang.Object
- - org.apache.cxf.transport.AbstractObservable
  - - org.apache.cxf.transport.AbstractDestination
    - - org.apache.cxf.transport.AbstractMultiplexDestination

- All Implemented Interfaces:
    `Destination`, `DestinationWithEndpoint`, `MultiplexDestination`, `Observable`

      public abstract class AbstractMultiplexDestination
      extends AbstractDestination
      implements MultiplexDestination

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class org.apache.cxf.transport.AbstractDestination

      `AbstractDestination.AbstractBackChannelConduit`

  - ### Field Summary

    - ### Fields inherited from class org.apache.cxf.transport.AbstractDestination

      `bus, endpointInfo, reference`

    - ### Fields inherited from class org.apache.cxf.transport.AbstractObservable

      `incomingObserver`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `AbstractMultiplexDestination​(Bus b, org.apache.cxf.ws.addressing.EndpointReferenceType ref, EndpointInfo ei)` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `org.apache.cxf.ws.addressing.EndpointReferenceType` | `getAddressWithId​(String id)` | Builds an new endpoint reference using the current target reference as a template.
    `String` | `getId​(Map<String,​Object> contextMap)` | Obtain id from reference parameters of the ws-a to address Requires the existance of ws-a interceptors on dispatch path to provide access to the ws-a headers

    - ### Methods inherited from class org.apache.cxf.transport.AbstractDestination

      `getAddress, getBackChannel, getEndpointInfo, getInbuiltBackChannel, shutdown`

    - ### Methods inherited from class org.apache.cxf.transport.AbstractObservable

      `activate, deactivate, getLogger, getMessageObserver, getTargetReference, getTargetReference, setMessageObserver`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface org.apache.cxf.transport.Destination

      `getAddress, getBackChannel, getMessageObserver, shutdown`

    - ### Methods inherited from interface org.apache.cxf.transport.Observable

      `setMessageObserver`

- - ### Constructor Detail

    - #### AbstractMultiplexDestination

          public AbstractMultiplexDestination​(Bus b,
                                              org.apache.cxf.ws.addressing.EndpointReferenceType ref,
                                              EndpointInfo ei)

  - ### Method Detail

    - #### getAddressWithId

          public org.apache.cxf.ws.addressing.EndpointReferenceType getAddressWithId​(String id)

      Builds an new endpoint reference using the current target reference as a template. The supplied id is endcoded using a reference parameter. This requires the ws-a interceptors to propagate the reference parameters on subsequent invokes using the returned reference.
      Specified by:
        `getAddressWithId` in interface `MultiplexDestination`
      Parameters:
        `id` - the id to encode in the new reference
      Returns:
        the new reference with the id encoded as a reference parameter
      See Also:
        `MultiplexDestination.getAddressWithId(java.lang.String)`

    - #### getId

          public String getId​(Map<String,​Object> contextMap)

      Obtain id from reference parameters of the ws-a to address Requires the existance of ws-a interceptors on dispatch path to provide access to the ws-a headers
      Specified by:
        `getId` in interface `MultiplexDestination`
      Parameters:
        `contextMap` - the current invocation or message context
      Returns:
        the id from the reference parameters of the ws-a-to address or null if not found
      See Also:
        `MultiplexDestination.getId(java.util.Map)`